// DemoDlg.cpp : implementation file
//

#include "stdafx.h"

#include <iostream.h>
#include <stdlib.h>
#include <string.h>

#include "atlconv.h"
#include "comutil.h"

#include "Demo.h"
#include "DemoDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_CHECK_UNICODE_MESSAGE, m_UnicodeMsg);
	DDX_Control(pDX, IDC_EDIT_HEIGHT, m_txtHeight);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_txtWidth);
	DDX_Control(pDX, IDC_COMBO_ORIENTATION, m_cbxOrientation);
	DDX_Control(pDX, IDC_COMBO_Y2X_RATIO, m_cbxY2XRatio);
	DDX_Control(pDX, IDC_COMBO_NARROW_BAR_WIDTH, m_cbxNarrowBarWidth);
	DDX_Control(pDX, IDC_CHECK_PROCESS_TILDE, m_chkProcessTilde);
	DDX_Control(pDX, IDC_CHECK_TRUNCATE_SYMBOL, m_chkTruncateSymbol);
	DDX_Control(pDX, IDC_COMBO_MODE, m_cbxMode);
	DDX_Control(pDX, IDC_EDIT_COLUMNS, m_txtCols);
	DDX_Control(pDX, IDC_EDIT2, m_txtRows);
	DDX_Control(pDX, IDC_COMBO_ECLEVEL, m_cbxECLevel);
	DDX_Control(pDX, IDC_EDIT_MESSAGE, m_txtMessage);
	DDX_Control(pDX, IDC_PDF4171, m_PDF417Ctrl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PRINT1, OnButtonPrint1)
	ON_BN_CLICKED(IDC_BUTTON_BMP, OnButtonBmp)
	ON_BN_CLICKED(IDC_BUTTON_PRINT2, OnButtonPrint2)
	ON_BN_CLICKED(IDC_BUTTON_WMF, OnButtonWmf)
	ON_BN_CLICKED(IDC_BUTTON_COPY, OnButtonCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_txtMessage.SetWindowText("1234");
	m_cbxMode.SetCurSel(0);
	m_cbxNarrowBarWidth.SetCurSel(2);
	m_chkProcessTilde.SetCheck(false);
	m_chkTruncateSymbol.SetCheck(false);
	m_txtRows.SetWindowText("6");
	m_txtCols.SetWindowText("4");
	m_cbxECLevel.SetCurSel(2);
	m_cbxY2XRatio.SetCurSel(0);
	m_cbxOrientation.SetCurSel(0);
	m_txtWidth.SetWindowText("90");
	m_txtHeight.SetWindowText("100");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoDlg::Update_Barcode()
{
	CString tmp;
	double d;
	int v;

	m_txtMessage.GetWindowText(tmp);

	if (m_UnicodeMsg.GetCheck() == false)
	{
		// a regular string
		m_PDF417Ctrl.SetData(tmp);

		m_PDF417Ctrl.SetHandleTilde(m_chkProcessTilde.GetCheck()); 
	}
	else
	{
		// a Unicode message
		// convert it to a UTF8 byte stream
		USES_CONVERSION;
		int len = WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)A2W(tmp), -1, NULL, 0, NULL, NULL);

		char *temp_str = new char[len + 1];
		int res = WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)A2W(tmp), -1, temp_str, len, NULL, NULL);
		if (res == 0)
		{
			return; 
		}

		char *buffer = new char[5 * (len - 1) + 1];
		memset(buffer, 0, 5 * (len - 1) + 1);

		// The last byte value is always 0, so ignore it
		// use the "~dNNN" format to represent a character
		// It is a good practice to represent those characters with the ASCII value >= 128
		for (int i = 0; i < (len - 1); i++)
		{
			buffer[5 * i] = '~';
			buffer[5 * i + 1] = 'd';

			unsigned char ch_val = (unsigned char)temp_str[i];
			buffer[5 * i + 2] = ((ch_val / 100) + '0');

			ch_val = ch_val % 100;
			buffer[5 * i + 3] = ((ch_val / 10) + '0');

			ch_val = ch_val % 10;
			buffer[5 * i + 4] = (ch_val + '0');
		}

		m_PDF417Ctrl.SetData((LPCTSTR)buffer);

		m_PDF417Ctrl.SetHandleTilde(true); 

		delete [] buffer;
		delete [] temp_str;
	}

	m_PDF417Ctrl.SetErrorCorrectionLevel(m_cbxECLevel.GetCurSel());
	m_PDF417Ctrl.SetMode(m_cbxMode.GetCurSel());
	
	m_PDF417Ctrl.SetTruncateSymbol(m_chkTruncateSymbol.GetCheck());
	m_PDF417Ctrl.SetOrientation(m_cbxOrientation.GetCurSel());

	m_cbxNarrowBarWidth.GetWindowText(tmp);
	d = strtod(tmp, 0);
	m_PDF417Ctrl.SetNarrowBarWidth((float)d);

	m_cbxY2XRatio.GetWindowText(tmp);
	d = strtod(tmp, 0);
	m_PDF417Ctrl.SetY2XRatio((float)d);

	m_txtRows.GetWindowText(tmp);
	v = strtoul(tmp, 0, 10);
	m_PDF417Ctrl.SetRows((short)v);

	m_txtCols.GetWindowText(tmp);
	v = strtoul(tmp, 0, 10);
	m_PDF417Ctrl.SetColumns((short)v);

	m_txtWidth.GetWindowText(tmp);
	m_ExtraWidth = strtoul(tmp, 0, 10);

	m_txtHeight.GetWindowText(tmp);
	m_ExtraHeight = strtoul(tmp, 0, 10);
}

void CDemoDlg::OnButtonPrint1() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	long ActualWidth, ActualHeight;
	HDC hPrinterDC;

    // Get the Printer Dialog
	CPrintDialog *printerDlg = new CPrintDialog(FALSE, PD_ALLPAGES | PD_RETURNDC, NULL);

    // Do the initialization 
	printerDlg->m_pd.nFromPage = printerDlg->m_pd.nToPage = 1;
    printerDlg->m_pd.nMinPage = printerDlg->m_pd.nMaxPage = 1;

    // Display the Printer Dialog.
    printerDlg->DoModal();

    // Get the handle of the printer.
    hPrinterDC = printerDlg->GetPrinterDC();
    if (hPrinterDC != NULL)
    {
		CDC *pDC = new CDC;
		// Attach the printer DC
        pDC->Attach(hPrinterDC);     

		// Start a new print job
        pDC->StartDoc("sample barcode");  
                                 
		// Start a new page
        pDC->StartPage();

		// Get the actual barcode width and height
		// Render the PDF417 barcode on the printer
		m_PDF417Ctrl.GetActualSize(FALSE, (long)hPrinterDC, &ActualWidth, &ActualHeight);

		// Image size = barcode size + surrounding white space
		if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2)
			m_PDF417Ctrl.SetSize(ActualWidth + m_ExtraWidth, ActualHeight + m_ExtraHeight);
		else
			m_PDF417Ctrl.SetSize(ActualHeight + m_ExtraWidth, ActualWidth + m_ExtraHeight);

		// The barcode is printed at the point (100, 500)
		// (x = 100, y = 500)
		m_PDF417Ctrl.Render((long)(pDC->m_hDC), 100, 500);

		// End the current page
        pDC->EndPage();            

		// End the current print job
        pDC->EndDoc();    
		
		// Detach the printer DC
        pDC->Detach();
		
        delete pDC;
	}

    delete printerDlg;
}

void CDemoDlg::OnButtonPrint2() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	HDC hPrinterDC;

    // Get the Printer Dialog
	CPrintDialog *printerDlg = new CPrintDialog(FALSE, PD_ALLPAGES | PD_RETURNDC, NULL);

    // Do the initialization 
	printerDlg->m_pd.nFromPage = printerDlg->m_pd.nToPage = 1;
    printerDlg->m_pd.nMinPage = printerDlg->m_pd.nMaxPage = 1;

    // Display the Printer Dialog.
    printerDlg->DoModal();

    // Get the handle of the printer.
    hPrinterDC = printerDlg->GetPrinterDC();
    if (hPrinterDC != NULL) {
		CDC *pDC = new CDC;
		// Attach the printer DC
        pDC->Attach(hPrinterDC);     

		// Start a new print job
        pDC->StartDoc("sample barcode");  
                                 
		// Start a new page
        pDC->StartPage();

		short *data = new short[1];
		long size = 1;
		BOOL result;
		short PatternRows, PatternCols;
		short RectWidth, RectHeight;
		short New_Rows, New_Cols;

		// First get buffer size
		m_PDF417Ctrl.GetPatternData(data, &size, &PatternRows, &PatternCols, &result);
		if (!result) {
			// Create an array
			delete [] data;
			data = new short[size];

			// Obtain pattern matrix data
			m_PDF417Ctrl.GetPatternData(data, &size, &PatternRows, &PatternCols, &result);
		}

		if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2) {
			RectWidth = (int)(::GetDeviceCaps(hPrinterDC, LOGPIXELSX) * m_PDF417Ctrl.GetNarrowBarWidth() /2.54);
			RectHeight = (int)(RectWidth * m_PDF417Ctrl.GetY2XRatio());

			New_Rows = PatternRows;
			New_Cols = PatternCols;
		}
		else {
			RectHeight = (int)(::GetDeviceCaps(hPrinterDC, LOGPIXELSY) * m_PDF417Ctrl.GetNarrowBarWidth() /2.54);
			RectWidth = (int)(RectHeight * m_PDF417Ctrl.GetY2XRatio());

			New_Cols = PatternRows;
			New_Rows = PatternCols;
		}
		
		HBRUSH sb = CreateSolidBrush(RGB(0, 0, 0));
		
		int Start_X = 100;
		int Start_Y = 150;
		int X = Start_X;
		int Y = Start_Y;
		BOOL IsBar;
        short BarCount;
		if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2) {
			for (int i = 1; i <= New_Rows; i++) {
				X = Start_X;
				IsBar = true;
				BarCount = 0;
				for (int j = 1; j <= New_Cols; j++) {
					short OneElement = GetElement(data, New_Rows, New_Cols, i, j);
					if (OneElement == '1' && IsBar) {
						// Another narrow bar
						BarCount = BarCount + 1;
					}
					else if (OneElement == '1' && !IsBar) {
						// A narrow bar appears
						IsBar = true;
						BarCount = 1;
					}
					else if (OneElement == '0' && IsBar) {
						// Draw continuous narrow bars
						RECT rc;
						rc.left = X;
						rc.top = Y;
						rc.right = rc.left + BarCount * RectWidth;
						rc.bottom = rc.top + RectHeight;
                
						FillRect(hPrinterDC, &rc, sb);
						X = X + BarCount * RectWidth;
						X = X + RectWidth;
                
						IsBar = false;
					}
					else if (OneElement == '0' && !IsBar) {
						// Space bar (no drawing is required)
						X = X + RectWidth;
					}
				}

				if (IsBar) {
					// Draw continuous narrow bars
					RECT rc;
					rc.left = X;
					rc.top = Y;
					rc.right = rc.left + BarCount * RectWidth;
					rc.bottom = rc.top + RectHeight;
            
					FillRect(hPrinterDC, &rc, sb);
				}
				Y = Y + RectHeight;
			}
		}
		else {
			for (int i = 1; i <= New_Cols; i++) {
				Y = Start_Y;
				IsBar = true;
				BarCount = 0;
				for (int j = 1; j <= New_Rows; j++) {
					short OneElement = GetElement(data, New_Rows, New_Cols, j, i);
					if (OneElement == '1' && IsBar) {
						// Another narrow bar
						BarCount = BarCount + 1;
					}
					else if (OneElement == '1' && !IsBar) {
						// A narrow bar appears
						IsBar = true;
						BarCount = 1;
					}
					else if (OneElement == '0' && IsBar) {
						// Draw continuous narrow bars
						RECT rc;
						rc.left = X;
						rc.top = Y;
						rc.right = rc.left + RectWidth;
						rc.bottom = rc.top + BarCount * RectHeight;
                
						FillRect(hPrinterDC, &rc, sb);
						Y = Y + BarCount * RectHeight;
						Y = Y + RectHeight;
                
						IsBar = false;
					}
					else if (OneElement == '0' && !IsBar) {
						// Space bar (no drawing is required)
						Y = Y + RectHeight;
					}
				}

				if (IsBar) {
					// Draw continuous narrow bars
					RECT rc;
					rc.left = X;
					rc.top = Y;
					rc.right = rc.left + RectWidth;
					rc.bottom = rc.top + BarCount * RectHeight;
            
					FillRect(hPrinterDC, &rc, sb);
					Y = Y + BarCount * RectHeight;
					Y = Y + RectHeight;
            
					IsBar = false;
				}
				X = X + RectWidth;
			}
		}

		// End the current page
        pDC->EndPage();            

		// End the current print job
        pDC->EndDoc();    
		
		// Detach the printer DC
        pDC->Detach();
		
        delete pDC;

		delete [] data;
		DeleteObject(sb);
	}

    delete printerDlg;
}

short CDemoDlg::GetElement(short *Data, short RowsCount, short ColsCount, short RowIndex, short ColIndex)
{
	if (m_cbxOrientation.GetCurSel() == 0)
		return *(Data + (RowIndex - 1) * ColsCount + ColIndex - 1);
	else if (m_cbxOrientation.GetCurSel() == 1)
		return *(Data + (ColIndex - 1) * RowsCount + RowsCount - RowIndex);
	else if (m_cbxOrientation.GetCurSel() == 2)
		return *(Data + (RowsCount - RowIndex) * ColsCount + ColsCount - ColIndex);
	else
		return *(Data + (ColsCount - ColIndex) * RowsCount + RowIndex - 1);
}

void CDemoDlg::OnButtonBmp() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
	m_PDF417Ctrl.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2)
		m_PDF417Ctrl.SetSize(ActualWidth + m_ExtraWidth, ActualHeight + m_ExtraHeight);
	else
		m_PDF417Ctrl.SetSize(ActualHeight + m_ExtraWidth, ActualWidth + m_ExtraHeight);

	m_PDF417Ctrl.SaveAsBMP("c:\\barcode_6.bmp");
}

void CDemoDlg::OnButtonWmf() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
	m_PDF417Ctrl.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2)
		m_PDF417Ctrl.SetSize(ActualWidth + m_ExtraWidth, ActualHeight + m_ExtraHeight);
	else
		m_PDF417Ctrl.SetSize(ActualHeight + m_ExtraWidth, ActualWidth + m_ExtraHeight);

	m_PDF417Ctrl.SaveAsWMF("c:\\barcode.wmf");
}

void CDemoDlg::OnButtonCopy() 
{
	// TODO: Add your control notification handler code here
	Update_Barcode();

	long ActualWidth, ActualHeight;

	// Get the actual barcode width and height
	m_PDF417Ctrl.GetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	if (m_cbxOrientation.GetCurSel() == 0 || m_cbxOrientation.GetCurSel() == 2)
		m_PDF417Ctrl.SetSize(ActualWidth + m_ExtraWidth, ActualHeight + m_ExtraHeight);
	else
		m_PDF417Ctrl.SetSize(ActualHeight + m_ExtraWidth, ActualWidth + m_ExtraHeight);

	m_PDF417Ctrl.CopyToClipboard();
}

void CDemoDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

